﻿using System;

namespace HttpCrawler.Engine
{
    public interface IHttpCrawlerEngineLogger
    {
        void DownloadFailure(Uri url, Exception exception);
        void DownloadSuccess(Uri url);
        void ProcessSuccess(IHttpCrawlerContentProcessor processor, HttpCrawlerContent content);
        void ProcessFailed(IHttpCrawlerContentProcessor processor, HttpCrawlerContent content, Exception exception);
        void Log(string message);
        void PersistContentSuccess(IHttpCrawlerContentPersister persister, HttpCrawlerContent content);
        void PersistContentFailed(IHttpCrawlerContentPersister persister, HttpCrawlerContent content, Exception exception);
    }
}
